
; x64-Version of MichaelW's macros
counter_begin MACRO loopcount:REQ, priority
LOCAL label

	IFNDEF tmcb__nLoops
		.data
			align 16
			tmcb__nLoops	dd 0
			tmcb__cntr		dd 0
			tmcb__qw		dq 2 dup (?)
		.code
	ENDIF

	mov tmcb__nLoops,loopcount
	IFNB <priority>
		call GetCurrentProcess
		mov rdx,priority
		mov rcx,rax
		call SetPriorityClass
	ENDIF
	xor rax,rax
	cpuid
	rdtsc

	mov DWORD ptr tmcb__qw[0],eax
	mov DWORD ptr tmcb__qw[4],edx
	mov tmcb__cntr, loopcount
	xor rax,rax
	cpuid
	align 16
@@:
	sub tmcb__cntr,1
	jnz @B

	xor rax,rax
	cpuid
	rdtsc
	shl rdx,32
	or rax,rdx
	sub rax,tmcb__qw[0]
	mov tmcb__qw[0],rax

	xor rax, rax
	cpuid
	rdtsc
	mov tmcb__cntr,loopcount
	mov DWORD ptr tmcb__qw[8],eax
	mov DWORD ptr tmcb__qw[12],edx
	xor rax,rax
	cpuid
	align 16
label:
	tmcb__label equ <label>
ENDM

; x64-Version of MichaelW's macros
counter_end MACRO
	sub tmcb__cntr,1
	jnz tmcb__label

	xor rax,rax
	cpuid
	rdtsc
	shl rdx,32
	or rax,rdx
	sub rax,tmcb__qw[0]
	sub rax,tmcb__qw[8]
	mov tmcb__qw[0],rax

	call GetCurrentProcess
	mov rdx,NORMAL_PRIORITY_CLASS
	mov rcx,rax
	call SetPriorityClass

	IFDEF _EMMS
		EMMS
	ENDIF

	finit
	fild tmcb__qw[0]
	fild tmcb__nLoops
	fdiv
	fistp tmcb__qw[0]

	mov rax,tmcb__qw[0]
ENDM

simplwsz macro lbl:LABEL,txt:=<>

    FOR arg,<&txt>
    	simplwsz_arg TEXTEQU <&arg>
    ENDM
    IFB simplwsz_arg
    	EXITM
    ENDIF
	simplwsz_pos1 INSTR 1,simplwsz_arg,<">
	simplwsz_pos2 INSTR 1,simplwsz_arg,<'>
	align 2
	lbl LABEL WORD
	IF simplwsz_pos1 EQ 1
	%	FORC char,<@SubStr(%simplwsz_arg,2,@SizeStr(%simplwsz_arg)-2)>
			dw "&char"
		ENDM
	ELSEIF simplwsz_pos2 EQ 1
	%	FORC char,<@SubStr(%simplwsz_arg,2,@SizeStr(%simplwsz_arg)-2)>
			dw '&char'
		ENDM
	ELSE
		dw simplwsz_arg
    ENDIF
    dw 0 
    EXITM
endm

repargw macro args:VARARG
	IFNDEF repargw_glb_cntr
		repargw_glb_cntr = 0
	ENDIF	
	repargw_cntr = 0
	repargw_args TEXTEQU <>
%	FOR arg,<&args>
		repargw_txt  TEXTEQU <&arg>
		repargw_pos1 INSTR 1,<&arg>,<">
		repargw_pos2 INSTR 1,<&arg>,<'>
		repargw_pos3 INSTR 1,<&arg>,<L">
		repargw_pos4 INSTR 1,<&arg>,<L'>
		IF repargw_pos1 EQ 1 OR repargw_pos2 EQ 1 OR repargw_pos3 EQ 1 OR repargw_pos4 EQ 1
			IF repargw_pos3 EQ 1 OR repargw_pos4 EQ 1
				repargw_txt SUBSTR repargw_txt,2
			ENDIF
			_DATA SEGMENT
				IF @SizeStr(<%repargw_txt>) GT 2
					@CatStr(<repargw_lbl_>,%repargw_glb_cntr) simplwsz <%repargw_txt>
				ELSE
					@CatStr(<repargw_lbl_>,%repargw_glb_cntr) dw 0
				ENDIF
			_DATA ENDS
			IFNB repargw_args
				repargw_args TEXTEQU repargw_args,<,OFFSET repargw_lbl_>,%repargw_glb_cntr
			ELSE
				repargw_args TEXTEQU <OFFSET repargw_lbl_>,%repargw_glb_cntr
			ENDIF
			repargw_glb_cntr = repargw_glb_cntr + 1
		ELSE
			IFNB repargw_args
				repargw_args TEXTEQU repargw_args,<,>,repargw_txt
			ELSE
				repargw_args TEXTEQU repargw_txt
			ENDIF
		ENDIF
		repargw_cntr = repargw_cntr + 1
	ENDM
	EXITM repargw_args
endm

wsz_chk macro arg
	IFNDEF repargw_glb_cntr
		repargw_glb_cntr = 0
	ENDIF
	
	repargw_txt  TEXTEQU <&arg>
	repargw_pos1 INSTR 1,<&arg>,<">
	repargw_pos2 INSTR 1,<&arg>,<'>
	repargw_pos3 INSTR 1,<&arg>,<L">
	repargw_pos4 INSTR 1,<&arg>,<L'>
	IF repargw_pos1 EQ 1 OR repargw_pos2 EQ 1 OR repargw_pos3 EQ 1 OR repargw_pos4 EQ 1
		IF repargw_pos3 EQ 1 OR repargw_pos4 EQ 1
			repargw_txt SUBSTR repargw_txt,2
		ENDIF
		_DATA SEGMENT
			IF @SizeStr(<%repargw_txt>) GT 2
				@CatStr(<repargw_lbl_>,%repargw_glb_cntr) simplwsz <%repargw_txt>
			ELSE
				@CatStr(<repargw_lbl_>,%repargw_glb_cntr) dw 0
			ENDIF
		_DATA ENDS
		repargw_txt TEXTEQU <OFFSET repargw_lbl_>,%repargw_glb_cntr
		repargw_glb_cntr = repargw_glb_cntr + 1
		EXITM repargw_txt
	ELSE
		EXITM repargw_txt
	ENDIF
endm

unique_num_cntr = 0
get_unique_lbl macro name:req
	unique_num_cntr = unique_num_cntr + 1
	EXITM @CatStr(<&name>,%unique_num_cntr)
endm

print macro lit:VARARG

	prnt_lit TEXTEQU repargw(lit)
	prnt_args TEXTEQU <>
	prnt_cntr = 0

%	FOR arg,<prnt_lit>
		IF @InStr(1,<&arg>,<ADDR >) OR @InStr(1,<&arg>,<addr >) OR @InStr(1,<&arg>,<Addr >)
			prnt_args TEXTEQU prnt_args,<,arg>
		ELSEIF ((OPATTR arg) XOR 100100y) EQ 0
			prnt_lbl TEXTEQU get_unique_lbl(<prnt_lbl_>)
			_DATA SEGMENT
				align 2
				prnt_lbl dw arg
						 dw 0
			_DATA ENDS
			prnt_args TEXTEQU prnt_args,<,OFFSET >,prnt_lbl
		ELSE
			prnt_args TEXTEQU prnt_args,<,arg>
		ENDIF
		prnt_cntr = prnt_cntr + 1
	ENDM
	
	IF prnt_cntr GT 4
		prnt_rsp_add = (prnt_cntr-4)*8+((prnt_cntr-4) AND 1)*8
		add rsp,-1*(prnt_rsp_add)
	ENDIF
	
	prnt_args CATSTR <invoke print_wsz,>,%prnt_cntr,prnt_args
	prnt_args

	IF prnt_cntr GT 4
		add rsp,prnt_rsp_add
	ENDIF	
endm

inkey macro lit:VARARG
	IFNB <&lit>
		print lit
	ELSE
		print "Press any key to continue ..."
	ENDIF
	call wait_key
	print wsz$(13,10)
ENDM

;-------------------------------------------------------------
; creates an unicode string in current segment
; 	lbl:	 [optional] name of string 
; 	args:	 one ore more string literals enclosed
;			 either by double or by singel quotes.
;			 Numeric values are also accepted, blank 
;			 arguments foreced an error. The maximal number
;			 of characters is something about 200.
;
;	remarks: an termination zero must add by user!
;			 Named strings can be used with the LENGTHOF
;			 or SIZEOF operator.
;			 This macro wont work with angle brackets and
;			 exclemation marks. If these char. are needed use the
;			 CWSZ-macro. 
;   example:
;	   WSTR wszXYZ,'"double quote"',10,13,"'single quote'",0
;-------------------------------------------------------------
WSZ macro lbl,args:VARARG
	IFNDEF wsz_lbl_cntr
		wsz_lbl_cntr = 0
	ENDIF
	IFB <&lbl>
		wsz_lbl TEXTEQU <anonym_WSTR_>,%wsz_lbl_cntr
		wsz_lbl_cntr = wsz_lbl_cntr + 1
	ELSE
		wsz_lbl TEXTEQU <&lbl>
	ENDIF
	wsz_line = 1
	wsz_line_1 TEXTEQU <>
	wsz_line_size = 0
	wsz_size = 0
	wsz_flg = 0
	wsz_iarg = 1
	
%	FOR _arg,<&args>
		wsz_flg = 0
		FORC char,<&_arg>
			IF wsz_flg NE 0
				wsz_pos INSTR 1,<"'>,<&char>
				IF wsz_pos EQ wsz_flg
					EXITM
				ELSE
					@CatStr(<wsz_line_>,%wsz_line) TEXTEQU @CatStr(%@CatStr(<wsz_line_>,%wsz_line)),<,>,wsz_quote,<&char>,wsz_quote
					IF wsz_line_size GE 160
						wsz_line = wsz_line + 1
						wsz_line_size = 0
						@CatStr(<wsz_line_>,%wsz_line) TEXTEQU <>
					ELSE
						wsz_line_size = wsz_line_size + 4
					ENDIF
					wsz_size = wsz_size + 1
				ENDIF
			ELSE
				wsz_flg INSTR 1,<"'0123456789>,<&char>
				IF wsz_flg NE 1 AND wsz_flg NE 2
					EXITM
				ENDIF
				wsz_quote TEXTEQU <&char>
				wsz_arg_size SIZESTR <&_arg>
				wsz_char SUBSTR <&_arg>,wsz_arg_size,1
				IFDIF wsz_char,wsz_quote
					wsz_flg=0
					EXITM
				ENDIF
			ENDIF
		ENDM
		IFE wsz_flg
			EXITM
		ELSEIF wsz_flg GT 2
			@CatStr(<wsz_line_>,%wsz_line) TEXTEQU @CatStr(%@CatStr(<wsz_line_>,%wsz_line)),<,>,<&_arg>
			IF wsz_line_size GE 160
				wsz_line = wsz_line + 1
				wsz_line_size = 0
				@CatStr(<wsz_line_>,%wsz_line) TEXTEQU <>
			ELSE
				wsz_line_size = wsz_line_size + @SizeStr(<&_arg>)
			ENDIF
			wsz_size = wsz_size + 1
		ENDIF		
		wsz_iarg = wsz_iarg + 1
	ENDM
	IFE wsz_flg
	%	.err <invalid string specifier : argument : @CatStr(%wsz_iarg)>
		EXITM
	ELSEIFE wsz_line_size
		wsz_line = wsz_line - 1
	ENDIF
	
	align 2
	IF wsz_line EQ 1
		wsz_lbl WORD @SubStr(%wsz_line_1,2);,0
	ELSE
		IFNB <&lbl>
		%	wsz_tmpS_&wsz_lbl struct
				wsz_lbl WORD wsz_size dup (?)
		%	wsz_tmpS_&wsz_lbl ends
		%	&wsz_lbl LABEL wsz_tmpS_&wsz_lbl
		ELSE
			wsz_lbl LABEL WORD
		ENDIF
		wsz_cntr = 1
		REPEAT wsz_line
			WORD @SubStr(%@CatStr(<wsz_line_>,%wsz_cntr),2)
			wsz_cntr = wsz_cntr + 1
		ENDM
		;WORD 0
	ENDIF
endm



;--------------------------------------
;
; function version of WSZ. 
; returns an OFFSET to anonym string.
;
;--------------------------------------
wsz$ macro args:VARARG
	IFNDEF wsz_lbl_cntr
		wsz_lbl_cntr = 0
	ENDIF
	wsz_lbl TEXTEQU <anonym_WSTR_>,%wsz_lbl_cntr
	wsz_lbl_cntr = wsz_lbl_cntr + 1

	wsz_line = 1
	wsz_line_1 TEXTEQU <>
	wsz_line_size = 0
	wsz_flg = 0
	wsz_iarg = 1
	
%	FOR _arg,<&args>
		wsz_flg = 0
		FORC char,<&_arg>
			IF wsz_flg NE 0
				wsz_pos INSTR 1,<"'>,<&char>
				IF wsz_pos EQ wsz_flg
					EXITM
				ELSE
					@CatStr(<wsz_line_>,%wsz_line) TEXTEQU @CatStr(%@CatStr(<wsz_line_>,%wsz_line)),<,>,wsz_quote,<&char>,wsz_quote
					IF wsz_line_size GE 160
						wsz_line = wsz_line + 1
						wsz_line_size = 0
						@CatStr(<wsz_line_>,%wsz_line) TEXTEQU <>
					ELSE
						wsz_line_size = wsz_line_size + 4
					ENDIF
				ENDIF
			ELSE
				wsz_flg INSTR 1,<"'0123456789>,<&char>
				IF wsz_flg NE 1 AND wsz_flg NE 2
					EXITM
				ENDIF
				wsz_quote TEXTEQU <&char>
				wsz_arg_size SIZESTR <&_arg>
				wsz_char SUBSTR <&_arg>,wsz_arg_size,1
				IFDIF wsz_char,wsz_quote
					wsz_flg=0
					EXITM
				ENDIF
			ENDIF
		ENDM
		IFE wsz_flg
			EXITM
		ELSEIF wsz_flg GT 2
			@CatStr(<wsz_line_>,%wsz_line) TEXTEQU @CatStr(%@CatStr(<wsz_line_>,%wsz_line)),<,>,<&_arg>
			IF wsz_line_size GE 160
				wsz_line = wsz_line + 1
				wsz_line_size = 0
				@CatStr(<wsz_line_>,%wsz_line) TEXTEQU <>
			ELSE
				wsz_line_size = wsz_line_size + @SizeStr(<&_arg>)
			ENDIF
		ENDIF		
		wsz_iarg = wsz_iarg + 1
	ENDM
	IFE wsz_flg
	%	.err <invalid string specifier : argument : @CatStr(%wsz_iarg)>
		EXITM <0>
	ELSEIFE wsz_line_size
		wsz_line = wsz_line - 1
	ENDIF
	.data
		align 2
	%	&wsz_lbl LABEL WORD
		wsz_cntr = 1
		REPEAT wsz_line
			WORD @SubStr(%@CatStr(<wsz_line_>,%wsz_cntr),2)
			wsz_cntr = wsz_cntr + 1
		ENDM
		WORD 0
	.code
%	EXITM <OFFSET &wsz_lbl> 
endm

;-------------------------------------------------
; creates an unicode string. This macro works 
; the same way like WSZ, but adds support for
; escape sequences:
; \\ :	"\"
; \t :	tab	
; \n :	new line
; \x :	"!"
; \a :	"("
; \b :	")"
; \l :	"<"
; \r :	">"
; \q :	double quote '"'
;-------------------------------------------------
CWSZ macro lbl,args:VARARG
	IFNDEF wsz_lbl_cntr
		wsz_lbl_cntr = 0
	ENDIF
	IFB <&lbl>
		wsz_lbl TEXTEQU <anonym_WSTR_>,%wsz_lbl_cntr
		wsz_lbl_cntr = wsz_lbl_cntr + 1
	ELSE
		wsz_lbl TEXTEQU <&lbl>
	ENDIF
	wsz_line = 1
	wsz_line_1 TEXTEQU <>
	wsz_line_size = 0
	wsz_size = 0
	wsz_flg = 0
	wsz_iarg = 1
	wsz_esc = 0
	
	FOR _arg,<&args>
		wsz_flg = 0
		FORC char,<&_arg>
			IF wsz_flg NE 0
				wsz_pos INSTR 1,<"'\>,<&char>
				IF wsz_pos EQ wsz_flg
					EXITM
				ELSEIF wsz_pos EQ 3 AND wsz_esc EQ 0
					wsz_esc = 1
				ELSE
					wsz_char TEXTEQU wsz_quote,<&char>,wsz_quote
					IF wsz_esc
						wsz_pos INSTR 1,<\ablrxqtn>,<&char>
						IFE wsz_pos
							wsz_flg=0
							EXITM
						ENDIF
						wsz_char SUBSTR <  5ch28h29h3ch3eh21h22h09h0ah,0dh>,wsz_pos*3,3+4*(wsz_pos/9)
						wsz_size = wsz_size + wsz_pos/9
						wsz_esc = 0
					ENDIF
					@CatStr(<wsz_line_>,%wsz_line) TEXTEQU @CatStr(%@CatStr(<wsz_line_>,%wsz_line)),<,>,wsz_char
					IF wsz_line_size GE 160
						wsz_line = wsz_line + 1
						wsz_line_size = 0
						@CatStr(<wsz_line_>,%wsz_line) TEXTEQU <>
					ELSE
						wsz_pos SIZESTR wsz_char
						wsz_line_size = wsz_line_size + wsz_pos + 1
					ENDIF
					wsz_size = wsz_size + 1
				ENDIF
			ELSE
				wsz_flg INSTR 1,<"'0123456789>,<&char>
				IF wsz_flg NE 1 AND wsz_flg NE 2
					EXITM
				ENDIF
				wsz_quote TEXTEQU <&char>
				wsz_arg_size SIZESTR <&_arg>
				wsz_char SUBSTR <&_arg>,wsz_arg_size,1
				IFDIF wsz_char,wsz_quote
					wsz_flg=0
					EXITM
				ENDIF
			ENDIF
		ENDM
		IF wsz_flg EQ 0 OR wsz_esc
			EXITM
		ELSEIF wsz_flg GT 2
			@CatStr(<wsz_line_>,%wsz_line) TEXTEQU @CatStr(%@CatStr(<wsz_line_>,%wsz_line)),<,>,<&_arg>
			IF wsz_line_size GE 160
				wsz_line = wsz_line + 1
				wsz_line_size = 0
				@CatStr(<wsz_line_>,%wsz_line) TEXTEQU <>
			ELSE
				wsz_line_size = wsz_line_size + @SizeStr(<&_arg>)
			ENDIF
			wsz_size = wsz_size + 1
		ENDIF		
		wsz_iarg = wsz_iarg + 1
	ENDM
	IF wsz_flg EQ 0 OR wsz_esc NE 0
		IF wsz_esc
		%	.err <invalid escape sequence : argument : @CatStr(%wsz_iarg)>
		ELSE
		%	.err <invalid string specifier : argument : @CatStr(%wsz_iarg)>
		ENDIF
		EXITM
	ELSEIFE wsz_line_size
		wsz_line = wsz_line - 1
	ENDIF
	
	align 2
	IF wsz_line EQ 1
		wsz_lbl WORD @SubStr(%wsz_line_1,2);,0
	ELSE
		IFNB <&lbl>
		%	wsz_tmpS_&wsz_lbl struct
				wsz_lbl WORD wsz_size dup (?)
		%	wsz_tmpS_&wsz_lbl ends
		%	&wsz_lbl LABEL wsz_tmpS_&wsz_lbl
		ELSE
			wsz_lbl LABEL WORD
		ENDIF
		wsz_cntr = 1
		REPEAT wsz_line
			WORD @SubStr(%@CatStr(<wsz_line_>,%wsz_cntr),2)
			wsz_cntr = wsz_cntr + 1
		ENDM
		;WORD 0
	ENDIF
endm

cwsz$ macro args:VARARG
	IFNDEF wsz_lbl_cntr
		wsz_lbl_cntr = 0
	ENDIF
	wsz_lbl TEXTEQU <anonym_WSTR_>,%wsz_lbl_cntr
	wsz_lbl_cntr = wsz_lbl_cntr + 1
	
	wsz_line = 1
	wsz_line_1 TEXTEQU <>
	wsz_line_size = 0
	wsz_flg = 0
	wsz_iarg = 1
	wsz_esc = 0
	
	FOR _arg,<&args>
		wsz_flg = 0
		FORC char,<&_arg>
			IF wsz_flg NE 0
				wsz_pos INSTR 1,<"'\>,<&char>
				IF wsz_pos EQ wsz_flg
					EXITM
				ELSEIF wsz_pos EQ 3 AND wsz_esc EQ 0
					wsz_esc = 1
				ELSE
					wsz_char TEXTEQU wsz_quote,<&char>,wsz_quote
					IF wsz_esc
						wsz_pos INSTR 1,<\ablrxqtn>,<&char>
						IFE wsz_pos
							wsz_flg=0
							EXITM
						ENDIF
						wsz_char SUBSTR <  5ch28h29h3ch3eh21h22h09h0ah,0dh>,wsz_pos*3,3+4*(wsz_pos/9)
						wsz_esc = 0
					ENDIF
					@CatStr(<wsz_line_>,%wsz_line) TEXTEQU @CatStr(%@CatStr(<wsz_line_>,%wsz_line)),<,>,wsz_char
					IF wsz_line_size GE 160
						wsz_line = wsz_line + 1
						wsz_line_size = 0
						@CatStr(<wsz_line_>,%wsz_line) TEXTEQU <>
					ELSE
						wsz_pos SIZESTR wsz_char
						wsz_line_size = wsz_line_size + wsz_pos + 1
					ENDIF
				ENDIF
			ELSE
				wsz_flg INSTR 1,<"'0123456789>,<&char>
				IF wsz_flg NE 1 AND wsz_flg NE 2
					EXITM
				ENDIF
				wsz_quote TEXTEQU <&char>
				wsz_arg_size SIZESTR <&_arg>
				wsz_char SUBSTR <&_arg>,wsz_arg_size,1
				IFDIF wsz_char,wsz_quote
					wsz_flg=0
					EXITM
				ENDIF
			ENDIF
		ENDM
		IF wsz_flg EQ 0 OR wsz_esc
			EXITM
		ELSEIF wsz_flg GT 2
			@CatStr(<wsz_line_>,%wsz_line) TEXTEQU @CatStr(%@CatStr(<wsz_line_>,%wsz_line)),<,>,<&_arg>
			IF wsz_line_size GE 160
				wsz_line = wsz_line + 1
				wsz_line_size = 0
				@CatStr(<wsz_line_>,%wsz_line) TEXTEQU <>
			ELSE
				wsz_line_size = wsz_line_size + @SizeStr(<&_arg>)
			ENDIF
		ENDIF		
		wsz_iarg = wsz_iarg + 1
	ENDM
	IF wsz_flg EQ 0 OR wsz_esc NE 0
		IF wsz_esc
		%	.err <invalid escape sequence : argument : @CatStr(%wsz_iarg)>
		ELSE
		%	.err <invalid string specifier : argument : @CatStr(%wsz_iarg)>
		ENDIF
		EXITM <0>
	ELSEIFE wsz_line_size
		wsz_line = wsz_line - 1
	ENDIF
	.data
		align 2
	%	&wsz_lbl LABEL WORD
		wsz_cntr = 1
		REPEAT wsz_line
			WORD @SubStr(%@CatStr(<wsz_line_>,%wsz_cntr),2)
			wsz_cntr = wsz_cntr + 1
		ENDM
		WORD 0
	.code
%	EXITM <OFFSET &wsz_lbl> 
endm

; greek capital letters
CAP_ALPHA   EQU <0391h>
CAP_BETA    EQU <0392h>
CAP_GAMMA   EQU <0393h>
CAP_DELTA   EQU <0394h>
CAP_EPSILON EQU <0395h>
CAP_ZETA    EQU <0396h>
CAP_ETA     EQU <0397h>
CAP_THETA   EQU <0398h>
CAP_IOTA    EQU <0399h>
CAP_KAPPA   EQU <039Ah>
CAP_LAMDA   EQU <039Bh>
CAP_MU      EQU <039Ch>
CAP_NU      EQU <039Dh>
CAP_XI      EQU <039Eh>
CAP_OMICRON EQU <039Fh>
CAP_PI      EQU <03A0h>
CAP_RHO     EQU <03A1h>
CAP_SIGMA   EQU <03A3h>
CAP_TAU     EQU <03A4h>
CAP_UPSILON EQU <03A5h>
CAP_PHI     EQU <03A6h>
CAP_CHI     EQU <03A7h>
CAP_PSI     EQU <03A8h>
CAP_OMEGA   EQU <03A9h>

; greek small letters
SML_ALPHA   EQU <03B1h>
SML_BETA    EQU <03B2h>
SML_GAMMA   EQU <03B3h>
SML_DELTA   EQU <03B4h>
SML_EPSILON EQU <03B5h>
SML_ZETA    EQU <03B6h>
SML_ETA     EQU <03B7h>
SML_THETA   EQU <03B8h>
SML_IOTA    EQU <03B9h>
SML_KAPPA   EQU <03BAh>
SML_LAMDA   EQU <03BBh>
SML_MU      EQU <03BCh>
SML_NU      EQU <03BDh>
SML_XI      EQU <03BEh>
SML_OMICRON EQU <03BFh>
SML_PI      EQU <03C0h>
SML_RHO     EQU <03C1h>
SML_SIGMA   EQU <03C3h>
SML_TAU     EQU <03C4h>
SML_UPSILON EQU <03C5h>
SML_PHI     EQU <03C6h>
SML_CHI     EQU <03C7h>
SML_PSI     EQU <03C8h>
SML_OMEGA   EQU <03C9h>


rv macro FncName:req,args:VARARG
	rvex_flag = 0
	rvex_cntr = 1	
	IF @InStr(1,<&FncName>,<=>)
		rvex_flag = 1
		rvex_dest SUBSTR <&FncName>,1,@InStr(1,<&FncName>,<=>)-1
		rvex_arg TEXTEQU <invoke >,@SubStr(<&FncName>,@InStr(1,<&FncName>,<=>)+1)
	ELSE	
		rvex_arg TEXTEQU <invoke FncName>
	ENDIF

	FOR var,<args>
  		rvex_pos INSTR 1,<&var>,<!&>
 		rvex_pos1 INSTR 1,<&var>,<!">
  		rvex_pos2 INSTR 1,<&var>,<!'>
  		IF(rvex_pos NE 0) AND (rvex_pos1 EQ 0) AND (rvex_pos2 EQ 0)
  			rvex_txt SUBSTR <var>,rvex_pos+1
  			rvex_arg CATSTR rvex_arg,<,ADDR >,rvex_txt
  		ELSE	
  			rvex_txt CATSTR <&var>
  			rvex_arg CATSTR rvex_arg,<,>,wsz_chk(%rvex_txt)
		ENDIF
		rvex_cntr = rvex_cntr + 1
	ENDM
	rvex_arg
	
	IF rvex_flag EQ 1
		IFNDEF _WIN64
			mov rvex_dest,eax
		ELSE
		%	IF (type rvex_dest) EQ 8
				mov rvex_dest,rax
			ELSE
				mov rvex_dest,eax
			ENDIF
		ENDIF
	ENDIF
	IFNDEF _WIN64
		EXITM <eax>
	ELSE
		EXITM <rax>
	ENDIF
endm

fn macro FncName:req,args:VARARG
	fnex_flag = 0
	fnex_cntr = 1
	fnex_pos = 0	
	IF @InStr(1,<&FncName>,<=>)
		fnex_flag = 1
		fnex_dest SUBSTR <&FncName>,1,@InStr(1,<&FncName>,<=>)-1
		fnex_arg TEXTEQU <invoke >,@SubStr(<&FncName>,@InStr(1,<&FncName>,<=>)+1)
	ELSE	
		fnex_arg TEXTEQU <invoke FncName>
	ENDIF

	FOR var,<args>
  		fnex_pos INSTR 1,<&var>,<!&>
 		fnex_pos1 INSTR 1,<&var>,<!">
  		fnex_pos2 INSTR 1,<&var>,<!'>
  		IF (fnex_pos NE 0) AND (fnex_pos1 EQ 0) AND (fnex_pos2 EQ 0)
  			fnex_txt SUBSTR <&var>,fnex_pos+1
  			fnex_arg CATSTR fnex_arg,<,ADDR >,fnex_txt
  		ELSE	
  			fnex_txt CATSTR <&var>
  			fnex_arg CATSTR fnex_arg,<,>,wsz_chk(%fnex_txt)
		ENDIF
		fnex_cntr = fnex_cntr + 1
	ENDM
	fnex_arg
	
	IF fnex_flag EQ 1
		IFNDEF _WIN64
			mov fnex_dest,eax
		ELSE
		%	IF (type fnex_dest) EQ 8
				mov fnex_dest,rax
			ELSE
				mov fnex_dest,eax
			ENDIF
		ENDIF
	ENDIF
endm

asm macro lit:VARARG
	
	?asm_pos1 INSTR 1,<&lit>,< >
	?asm_pos2 INSTR 1,<&lit>,<,>
	IF ?asm_pos2 EQ 0
		?asm_txt SUBSTR <&lit>,%?asm_pos1
	ELSE
		?asm_txt SUBSTR <&lit>,%?asm_pos1,%(?asm_pos2-?asm_pos1)
	ENDIF
	lit
	EXITM ?asm_txt
endm
